###########################################
#                                         #
# a big marker box for script sections    
#                                         #
###########################################

###########################################
# a smaller marker box for script sections    
###########################################


###########################################
# sed streameditor resources   
###########################################

# plain find and replace
sed 's/#enabled  = true/#enabled  = false/'

# find and replace including a write of newline
sed 's/enabled  = true/enabled  = true\nbantime = 600/'

# replace the contents of line 4 with "Port 22"
sed -i '4s/.*/Port 22/' sshd_config

# replace a string at (variable) line number
sed "$jaillineplus2 s/true/false/" < jail.local > jail.local1

# replaces a string and all rest of line, with a newstring and variable
# replaces in situ in the same file, sed -i
varib=33331
sed -i "s/String.*/Newstring${varib}/g" file.txt

# find and replace recursively into sub directories
# be careful working near system folders, use a purpose folder
find ./ -type f -readable -writable -exec sed -i "s/cybernetnews/cybernet/g" {} \;


###########################################
# end of sed stream editor rescources
###########################################

###########################################
# text manipulation snippets
###########################################

# return a variable "portline" that has the line no of grep,s find
# of "Port" as the 1st chrs in the variable
# $portline 4:Port 22 the 1st chrs could then be taken to ref the line
portline=$(grep -n Port sshredev.txt)

# cut the 4th character of a file into another file
cut -c4 newportforssh.txt &> newsshport4th.txt

# put the line number of the matching string into a file
fgrep -n "$jailfailing" < /etc/fail2ban/jail.local  > jaillinefull.txt

# increase a variable int/str? by 2
jaillineplus2=$(($jailline + 2))

# provides variable of line no where [ssh] is found
fail2sshheaderline=$(grep -n '\[ssh\]' /etc/fail2ban/jail.local)
echo $fail2sshheaderline > fail2sshheaderline.txt
sed -i 's/:.*//' fail2sshheaderline.txt
fail2sshheaderlineno=$(<fail2sshheaderline.txt)
echo "var is" $fail2sshheaderlineno

# swaps out lineno +3 of match [ssh], with string and variable newportforssh
fail2sshheaderline=$(grep -n '\[ssh\]' /etc/fail2ban/jail.local)
echo $fail2sshheaderline > fail2sshheaderline.txt
sed -i 's/:.*//' fail2sshheaderline.txt
fail2sshheaderlineno=$(<fail2sshheaderline.txt)
sshportlineno=$(($fail2sshheaderlineno + 3))
sed -i "$sshportlineno s/port.*/port     = ${newportforssh}/g" /etc/fail2ban/jail.local



###########################################
# end of text manipulation snippets
###########################################

